#include <tos.h>

typedef struct
{
	long	value;
	void	*param;
} cookie;

typedef int (*func)(int, long, long);
int ida_noop(int dummy){return -1+0*dummy;};
func ida_fn_adr = (func) ida_noop;

int
ida_init (void)
{
	long old_stack;
	cookie *keks;
	old_stack = Super(0l);
	keks = (cookie*)(*(long*)0x5a0);

	while ((keks->value!='_IDA') && (keks->value!=0))
		keks++;

	if (keks->value=='_IDA')
	{
		func adr;
	
		adr = (func)keks->param;
		ida_fn_adr = adr;
		Super((void *) old_stack);
		return 1;
	}
	Super((void *) old_stack);
	
	return (0);
}



int
ida_count (void)
{
	long old_stack;
 	int fn_nr;
 	
	int	value = -1;
	old_stack = Super(0l);
	Ikbdws(1,(void*)"\022");                            
	fn_nr = ida_fn_adr (1,'G_CL',0);                     
	if (fn_nr!=-1)
		value = ida_fn_adr (fn_nr, 0, 0);                          	
	Ikbdws (1, (void*) "\010");                          
	Super ((void *) old_stack);
	
	return value;
}

int
ida_test_emphasis(void)
{
long old_stack;
int fn_nr,value=-1;

	old_stack=Super(0l);
	fn_nr = ida_fn_adr (1, 'T_EM', 0);                  
	if (fn_nr!=-1)
		value = ida_fn_adr (fn_nr,0,0);	
	Super((void *) old_stack);
	return value;
}	

int
ida_select_input (int inp)
{
long old_stack;
int fn_nr,value=-1;

	old_stack=Super(0l);
	fn_nr = ida_fn_adr (1, 'S_IN', 0);                         /* SetINput */
	if (fn_nr!=-1)
		value = ida_fn_adr (fn_nr,inp,0);	
	Super((void *) old_stack);
	return value;
}	


int
ida_select_clocksource (int clock)
{                                          /* clock: 0 = PLL; 1 = Extern */
	long old_stack;
	int fn_nr, value = -1;
	
	clock *= 4;
	old_stack = Super(0l);
	fn_nr = ida_fn_adr (1, 'SCLS', 0);                /* SelectCLock */
	if (fn_nr != -1)
		value = ida_fn_adr (fn_nr, clock, 0);
	Super ((void *) old_stack);
	if(value==4)
		value = 1;
	return (value);
}

int
ida_select_clock (int clock)
{
	long old_stack;
	int fn_nr, value = -1;

	old_stack=Super(0l);
	fn_nr = ida_fn_adr (1, 'S_CL', 0);                      /* SelectCLock */
	if (fn_nr != -1)
		value = ida_fn_adr (fn_nr, clock, 0);
	Super((void *) old_stack);
	return value;
}

int
ida_set_mode (int mode)
{
	long old_stack;
	int fn_nr, value = -1;

	old_stack=Super(0l);
	fn_nr = ida_fn_adr (1, 'S_MO', 0);                          /* SetMOde */
	if (fn_nr != -1)
		value = ida_fn_adr (fn_nr, mode, 0);
	Super((void *) old_stack);	
	return value;
}
