#define	IDA_NAT			0			/* Definitionen fr Betriebsart */
#define	IDA_COMP		1
#define	IDA_C_REG		1			/* Definitionen fr Taktsource */
#define	IDA_C_PLL		0
#define IDA_CD    	0			/* Definitionen fr Sampelrate */
#define IDA_DAT		 	2
#define	IDA_DSR			1
#define	IDA_CD_M		3
#define	IDA_CA			0			/* Definitionen fr Eingangswahl */
#define	IDA_CB			1
#define IDA_OA			3
#define IDA_OB			2
#define IDA_EM			0     /* Definition fr Emphasis */
#define IDA_NO_EM		1			/* Keine Emphasis */

extern int ida_init (void);
/*-------------------------------------------------	
			ida_init : Dient zur Initialisierung der
			Treiberroutinen.
			Rckgabewert: 1 - Treiber installiert
										0	-	kein Treiber
--------------------------------------------------*/
extern int ida_count (void);
/*-------------------------------------------------	
			ida_count : Stellt die aktuelle Sampelrate
			fest.
			Mu bei einem Wechsel des Externen Taktes
			aufgerufen werden.
			Rckgabewert: 0 - 44.1 	kHz
										1	-	32		kHz
										2	-	48		kHz
										4	-	kein Takt
--------------------------------------------------*/

extern int ida_test_emphasis(void);
/*-------------------------------------------------
			ida_test_emphasis : Stellt fest ob ein Signal 
													mit Empasis anliegt.
				Rckgabewert: 0 - Keine Empasis
											1 - Empasis
-------------------------------------------------*/

extern int ida_select_input (int inp);
/*-------------------------------------------------	
			ida_select input : Legt den Eingangskanal fest.
										0 - Coaxial A
										1	-	Coaxial B
										2	-	Optisch B
										4	-	Optisch A
									-1	-	Der aktuell einstellte
									Status wird zurckgelesen.
			Rckgabewert: 0 - Coaxial A
										1	-	Coaxial B
										2	-	Optisch B
										4	-	Optisch A
--------------------------------------------------*/

extern int ida_select_clocksource (int clock);
/*-------------------------------------------------	
			ida_select_clocksource : Legt die Clocksource fest.
										0 - PLL - Takt
										1	-	Regenerierter Takt
									-1	-	Der aktuell einstellte
									Status wird zurckgelesen.
			Rckgabewert: 0 - PLL - Takt
										1	-	Regenerierter Takt
										
			Der regenerierte Takt sollte immer bei Aufnahmen
			benutzt werden.
--------------------------------------------------*/

extern int ida_select_clock (int clock);
/*-------------------------------------------------	
			ida_select_clock : Legt die Samplerate fest.
										0 - 44.1 	kHz
										1	-	32  	kHz
										2	-	48		kHz
										3	-	44.1	Khz CD-Mode
									-1	-	Der aktuell einstellte
									Status wird zurckgelesen.
			Rckgabewert: 0 - 44.1 	kHz
										1	-	32  	kHz
										2	-	48		kHz
										3	-	44.1	Khz CD-Mode
--------------------------------------------------*/

extern int ida_set_mode (int mode);
/*-------------------------------------------------	
			ida_set_mode : Legt die Betriebsart fest.
										0 - Native Mode
										1	-	Soundpool komp.
									-1	-	Der aktuell einstellte
									Status wird zurckgelesen.
			Rckgabewert: 0 - Native Mode
										1	-	Soundpool komp.
--------------------------------------------------*/
