
/* INCLUDE FILES
 *==========================================================================
 */
#include <aes.h>
#include <portab.h>
#include <stddef.h>
#include <cpxdata.h>		  	
#include <tos.h>
#include <stdio.h>
#include "idabind.h"
#include "ida.h"
#include "ida.rsh"
#include	<string.h>
#include	<ext.h>

extern 	int 	mode_e;
extern	int		input_e;
extern	int		clock_e;
extern	int		source_e;


#define	NAT			0
#define	COMP		1
#define	XB			2
#define	C_REG		1
#define	C_PLL		0
#define CD    	0
#define DAT		 	2
#define	DSR			1
#define	CD_M		3
#define	CA			0
#define	CB			1
#define OA			3
#define OB			2



/* PROTOTYPES
 *==========================================================================
 */
 

CPXINFO* cdecl cpx_init(XCPB *Xcpb);
WORD cdecl  cpx_call(GRECT *rect);
	


/* GLOBALS
 *==========================================================================
 */
 
XCPB *xcpb;			/* XControl Parameter Block   */
CPXINFO cpxinfo;

int  errno;			/* Used by the C Runtime library*/
OBJECT *tree;

int mode;
int	input;
int	ida_clock;
int	source;
int	field[4];


/***** GLOBAL VARIABLES FOR VDI ***/
WORD	contrl[12];
WORD	intin[128];
WORD	ptsin[128];
WORD	intout[128];
WORD	ptsout[128];


CPXINFO *cdecl cpx_init(XCPB *Xcpb )

{
    xcpb = Xcpb;
    
 /*   appl_init();*/
        
    if( xcpb->booting )
    {
    	memcpy(&mode,&mode_e,2);
    	memcpy(&ida_clock,&clock_e,2);
    	memcpy(&source,&source_e,2);
    	memcpy(&input,&input_e,2);
 /*   	
    	printf("\a");
    	printf("INPUT : %d\n",input);
    	printf("MODE : %d\n",mode);
    	printf("SOURCE : %d\n",source);
    	printf("ida_clock : %d\n",ida_clock);
    	getch();
   */ 	
    	if(ida_init()!=1)
				return(0);
    	ida_select_input(input);
     	ida_set_mode(mode);
     	if(mode != COMP)
     	{
     		ida_select_clocksource(source);
     		ida_select_clock(ida_clock);
     		source=ida_select_clocksource(source);
     	}
		}
    else
    {    
      if( !xcpb->SkipRshFix )
         		(*xcpb->rsh_fix)(NUM_OBS,NUM_FRSTR,NUM_FRIMG,NUM_TREE,
         											rs_object,rs_tedinfo,rs_strings,rs_iconblk,
         											rs_bitblk,rs_frstr,rs_frimg,rs_trindex,
         											rs_imdope);
        tree = (OBJECT *)rs_trindex[MAINTREE];

      /* Get current hardware attributes here and store them away */
                 
      
      /* Initialize the CPXINFO structure */           
    	cpxinfo.cpx_call   	= cpx_call;
      cpxinfo.cpx_draw   	= NULL;
      cpxinfo.cpx_wmove  	= NULL;
      cpxinfo.cpx_timer 	= NULL;
      cpxinfo.cpx_key    	= NULL;
      cpxinfo.cpx_button 	= NULL;
      cpxinfo.cpx_m1 	 		= NULL;
      cpxinfo.cpx_m2	 		= NULL;
      cpxinfo.cpx_hook   	= NULL;
      cpxinfo.cpx_close  	= NULL;
      
      /* Return the pointer to the CPXINFO structure to XCONTROL */
     
    }
 	return &cpxinfo;
}

void display_corr(GRECT *rect)
{
 	if(mode != COMP)
     	{
     		tree[I441].ob_state = NORMAL;
     		tree[I48].ob_state = NORMAL;
     		tree[I32].ob_state = NORMAL;
     		tree[I441M].ob_state = NORMAL;
 				tree[EXT].ob_state = NORMAL;			

     	}
     	if(mode == COMP)
     	{
     		tree[I441].ob_state = DISABLED;
     		tree[I48].ob_state = DISABLED;
     		tree[I32].ob_state = DISABLED;
     		tree[I441M].ob_state = DISABLED;
     		tree[EXT].ob_state = DISABLED;

     	}
}

int set_display(GRECT *rect)
{


switch(mode)
			{
			case 	NAT:	tree[NATIVE].ob_state = SELECTED;
									break;
			case	COMP:	tree[COMPA].ob_state = SELECTED;
									break;
			/*case	XB:		tree[XBIOS].ob_state =SELECTED;
									break;*/
			}
			switch(input)
			{
			case	CA:	tree[INCA].ob_state = SELECTED;
								break;
			case	CB:	tree[INCB].ob_state = SELECTED;
								break;
			case	OA:	tree[INOA].ob_state	= SELECTED;
								break;
			case	OB:	tree[INOB].ob_state = SELECTED;
								break;
			}
			
			display_corr(rect);
			if(mode != COMP)
			{
			if(source == C_PLL)
			switch(ida_clock)
			{
			case	CD:		tree[I441].ob_state = SELECTED;
									break;
			case	DSR:	tree[I32].ob_state = SELECTED;
									break;
			case	DAT:	tree[I48].ob_state = SELECTED;
									break;
			case	CD_M:	tree[I441M].ob_state = SELECTED;
									break;
			}
			else 
				tree[EXT].ob_state = SELECTED;
			}
			
		
		  tree[ROOT].ob_x = rect->g_x;
  		tree[ROOT].ob_y = rect->g_y;
  		objc_draw( tree, ROOT, MAX_DEPTH,
   						rect ->g_x,rect->g_y,rect->g_w,rect->g_h);

			return(0);
}


WORD cdecl cpx_call(GRECT *rect)

{
		WORD button ;
		WORD msg[8];
		int quit;
   	int new;
   	quit=0;
		button =-1;
		
		if(ida_init()!=1)
			return(0);
		mode=ida_set_mode(-1);
		input=ida_select_input(-1);
		ida_clock=ida_select_clock(-1);
		source=ida_select_clocksource(-1);
		set_display(rect);		
		tree[ROOT].ob_x = rect->g_x;
    tree[ROOT].ob_y = rect->g_y;
    objc_draw( tree, ROOT, MAX_DEPTH,
     						rect ->g_x,rect->g_y,rect->g_w,rect->g_h);
    do
    {
   
    	quit = 0;
			button = (*xcpb->Xform_do)( tree, 0, msg );
	 		switch (button)
	 		{
	 			  
	 			case OK :			quit = 1;
	 										break;
	 		/*	case CANCEL : quit = 1;
	 										break;*/
	 			case	I441	:	ida_clock=CD;
	 										source=C_PLL;
	 										new=1;
	 										break;
	 			case	I48		:	ida_clock=DAT;
	 										source=C_PLL;
	 										new=1;
	 										break;
	 			case	I32		: ida_clock=DSR;
	 										source=C_PLL;
	 										new=1;
	 										break;
	 			case	I441M	:	ida_clock=CD_M;
	 										source=C_PLL;
	 										new=1;
	 										break;
	 			case 	INCA	: input = CA;
	 										new=1;
	 										break;
	 			case	INCB	:	input = CB;
	 										new = 1;
	 										break;
	 			case	INOA	:	input = OA;
	 										new=1;
	 										break;
	 			case	INOB	: input = OB;
	 										new=1;
	 										break;
	 			case	EXT		: source=C_REG;
	 										new = 1;
	 										break;
	 			case	SAVE	:	graf_mouse(BUSYBEE, 0L);
	 										field[0]=mode;
	 										field[1]=input;
	 										field[2]=ida_clock;
	 										field[3]=source;
	 										if(!(*xcpb->CPX_SAVE)(&field,8))
	 												(*xcpb->XGen_Alert)(FILE_ERR);
	 										graf_mouse(ARROW, 0L);
	 										tree[SAVE].ob_state &= ~SELECTED;
								    	objc_draw(tree,SAVE,1,rect ->g_x,rect->g_y,rect->g_w,rect->g_h);

	 										break;
	 			case	NATIVE:	
	 										mode 	= NAT;
	 										set_display(rect);
	 										break;
	 			case	COMPA	:	
	 										mode 	= COMP;
	 										set_display(rect);
	 										break;
	 			/*case	XBIOS	:	
	 										mode	=	XB;
	 										break;*/
	 										
	 			case	SCAN	:	ida_count();
	 										tree[SCAN].ob_state &= ~SELECTED;
	 							    	objc_draw(tree,SCAN,1,rect ->g_x,rect->g_y,rect->g_w,rect->g_h);
	 										break;
	 									
				default:  if(button==-1) 
									switch( msg[0] )
     				   				{
     				     					case WM_REDRAW: 
     				     		    	break;
     				     					case AC_CLOSE:
     				     						quit=1;
     				     		     	break;
     				     					case WM_CLOSED: 
     				     						quit = 1;
						    				 	break;
				    		 					case CT_KEY:
				     		    		 	break;	
				     							default:	break;     
     				   				}
     				   				break;
     	}
     	if(new==1)
     	{
     	ida_select_input(input);
     	ida_set_mode(mode);
     	if(mode != COMP)
     	{
     		ida_select_clocksource(source);
     		ida_select_clock(ida_clock);
     	}
     	new = 0;
     	}

    }
    while(quit!=1);
    tree[button].ob_state &= ~SELECTED;
    return( 0 );
}




